
(define (_cond es env)
  (cond [(null? es) (error '_cond "you are not so baller")]
        [(eq? (caar es) 'else) (_eval (cadar es) env)]
        [(_eval (caar es) env) (_eval (cadar es) env)]
        [else (_cond (cdr es) env)]))

(define (_quote es env)
  (car es))


(define global-identifiers
  '(car 
    cdr 
    cond 
    quote
    lambda))
(define global-values
  (list (list 1 'subr car) 
        (list 1 'subr cdr)
        (list 0 'fsubr _cond)
        (list 1 'fsubr _quote)
        (list 2 'fsubr _lambda)))


(define (indexk x xs k)
  (cond [(null? xs) -1]
        [(eq? x (car xs)) (k 0)]
        [else (indexk x (cdr xs) (lambda (res) (k (1+ res))))]))

(define (index x xs)
  (indexk x xs (lambda (res) res)))

(define (constant? e)
  (cond [(number? e) #t]
        [(string? e) #t]
        [(boolean? e) #t]
        [else #f]))

(define (variable? e)
  (symbol? e))

(define (lookup id env)
  (cond [(null? env) 
         ((lambda (pos) 
            (cond [(negative? pos) (error 'lookup "Unbound identifier")]
                  [else (car (list-tail global-values pos))])) 
            (index id global-identifiers))]
        [else 
         ((lambda (pos) 
            (cond [(negative? pos) (lookup id (cdr env))]
                  [else (car (list-tail (cdar env) pos))])) 
            (index id (caar env)))]))

(define (_eval e env)
  (cond [(constant? e) e]
        [(variable? e) (lookup e env)]
        [(pair? e) (_apply (_eval (car e) env) (cdr e) env)]))

(define (or b1 b2)
  (cond [b1 #t]
        [b2 #t]
        [else #f]))

(define (arity=? f n)
  (= (car f) n))

(define (subr? f)
  (eq? 'subr (cadr f)))
(define (proc? f)
  (eq? 'proc (cadr f)))
(define (fsubr? f)
  (eq? 'fsubr (cadr f)))

(define (_evals es env)
  (cond [(null? es) '()]
        [else (cons (_eval (car es) env) (_evals (cdr es) env))]))

(define (_apply f es env)
  (cond [(subr? f) 
         (cond [(arity=? f 0) ((caddr f))]
               [(arity=? f 1) ((caddr f) (_eval (car es) env))]
               [(arity=? f 2) ((caddr f) (_eval (car es) env) 
                               (_eval (cadr es) env))]
               [(arity=? f 3) ((caddr f) (_eval (car es) env) 
                               (_eval (cadr es) env) 
                               (_eval (caddr es) env))])]
        [(fsubr? f) 
         (cond [(or (arity=? f (length es))
                    (arity=? f 0))
                ((caddr f) es env)]
               [else (error '_apply "you still suck")])]
        [(proc? f) 
         (cond [(arity=? f (length es)) 
                ((caddr f) (_evals es env))]
               [else (error '_apply "you still suck")])]
        [else (error '_apply "watswag")]))

(define (_lambda es env)
  ((lambda (xs e)
     (list (length xs)
           'proc
           (lambda (vs) 
             (_eval e (cons (cons xs vs) env)))))
   (car es) (cadr es)))

















